 /*
Routine to read the lc-out files generated by fits2lc_r
Summarizes the data for further analysis.
Output to "sweethome/$argv[2]/lc_out.gnu"
*/

#include<stdio.h>
#include<math.h>
#include<stdlib.h>
#include<string.h>

#define firstevent 32000.0
#define detdim 65536
#define srcnum 20
#define DATA_POINTS 25000 

/*#include<dos.h>*/
/* list of input files */

/* ***************************************************************************** */

main(argc,argv)
int argc ;
char *argv[] ;
{

	FILE *in1, *in2, *in3;
	FILE *out ;

	char iiname[100], iname[100], oname[100], dummy[1024], sweethome[200];
        char surface[50][150];
          
        int i, j, k, orbit[200], pid[200], pidv[200], spix[4][200], bpix[4][200], jm, jemx;
        int cmp_full[4][200], lc_raw[4][200], lc_backgr[4][200], ee, jmax[4], selected[4][200]; 
        int collision, ival, ierr, ix, iy, normj[4];
        
        float lc_time[200], T_elapse[200], lc_livetime[200], norm_vals[4][200], lc_error[4][200];
        float neighbor_s[4][200], expfact[4][200], dimmyf, lc_rate[4][200], ratemax[4], rate, SN;
        float lc_ratex1[4][200], lc_ratex2[4][200], lc_ratex3[4][200], lc_ratex4[4][200];
        float lc_difmax[4][200], lc_X[200], lc_Y[200], norma[4], dimmy1, dimmy2, dimmy3, normhalf;
        
        /* ********************************************* */
        
        sprintf(sweethome, "/home/nl/jemx/crab");
        ee = 0;
        for (j=0; j<200; j++) for (ee=0; ee<4; ee++) selected[ee][j] = 0;        
        pid[199] = 999;
        
        if (argc > 2) jemx = atoi(argv[1]) ;           
        else {printf("jemx data_subdirectory\n"); return;}
        sprintf(iiname, argv[2]);

        for (ee=0; ee<4; ee++) {
           sprintf(dummy, "");
           sprintf(dummy, "%s/lc_summary_%1d_%1d.txt", iiname, jemx, ee);
           strcpy(oname, dummy);
           printf("output_file: %s\n", dummy);
           sprintf(dummy, "");
           sprintf(dummy, "%s/lc_out_%1d.txt", iiname, ee);
           strcpy(iname, dummy);
           printf("input_file: %s\n", dummy);
        
           in1 = fopen(iname, "rt");
           if (in1 == NULL) {
              printf("Could not open %s, exiting!\n", iname);
              return;
           }
           out = fopen(oname, "wt");
           if (out == NULL) {
              printf("Could not open %s, exiting!\n", oname);
              return;
           }

/*           printf(" orb  pid    T_stamp  T_elaps livetime  spix   raw   bpix  backg  norm_v  rate1  ");
           printf(" error   difmax  X     Y \n");
*/
        
           fgets(dummy, 140, in1);
        
           for (j=0; j<200; j++) {

              fgets(dummy, 140, in1);
              if (feof(in1)) goto end1;
              jm = j;
               /* read summary ascii file */
            
              sscanf(dummy, "%d %d %f %f %f %d %d %d %d %f %f %f %f %f %f %f %f %f %f", 
                 &orbit[j], &pid[j], &lc_time[j], &T_elapse[j], &lc_livetime[j], &spix[ee][j], &lc_raw[ee][j],
                 &bpix[ee][j], &lc_backgr[ee][j], &norm_vals[ee][j], &lc_rate[ee][j], &lc_error[ee][j],
                 &dimmy1, &dimmy2, &dimmy3, &dimmyf, &lc_difmax[ee][j], &lc_X[j], &lc_Y[j]);
                 
              if ((norma[ee] == 0) && (pid[j] > 5) && 
                                        (abs(lc_X[j] - 129.0) < 3.0) && (abs(lc_Y[j] - 130.0) < 3.0)) {
                 norma[ee] = lc_rate[ee][j] / 100.0;
                 normj[ee] = j;
              }
              if ((orbit[0] == 102) && (jemx == 1)) {
                 norma[0] = 0.35;
                 norma[1] = 0.68;
                 norma[2] = 0.36;
                 norma[3] = 0.21;
                 normj[ee] = 199;
              }
           }
end1:	;
   	   normhalf = norma[ee] * 0.5;
           
           printf("JEM-X%1d E%1d  Crab count rates across FOV from orbit %3d, pid %3d to orbit %3d, pid %3d\n", 
              jemx, ee, orbit[0], pid[0], orbit[jm-1], pid[jm-1]);
           fprintf(out, "JEM-X%1d E%1d  Crab count rates across FOV from orbit %3d, pid %3d to orbit %3d, pid %3d\n", 
              jemx, ee, orbit[0], pid[0], orbit[jm-1], pid[jm-1]);
           printf("Normalization at E=%1d, pid =%3d, X/Y: %6.2f / %6.2f,  rate: %6.2f\n", 
              ee, pid[normj[ee]], lc_X[normj[ee]], lc_Y[normj[ee]], norma[ee]*100.0);
           fprintf(out, "Normalization at E=%1d, pid =%3d, X/Y: %6.2f / %6.2f,  rate: %6.2f\n", 
              ee, pid[normj[ee]], lc_X[normj[ee]], lc_Y[normj[ee]], norma[ee]*100.0);
           for (i=0; i<50; i++) for (j=0; j<150; j++) surface[i][j] = ' ';
           for (j=0; j<jm; j++) {
              ix = (lc_X[j] - 30.0) * 12.0 / 20.0;
              iy = (lc_Y[j] - 40.0) * 5.0 / 20.0;

              collision = 0;
              for (i=ix-1; i<ix+8; i++) if (surface[iy][i] != ' ') collision = 1;
              if (collision == 1) iy--;
              collision = 0;
              for (i=ix-1; i<ix+8; i++) if (surface[iy][i] != ' ') collision = 1;
              if (collision == 1) iy--;

	      ival = lc_livetime[j] / 10.0;
              ierr = pid[j];

              ival = (lc_rate[ee][j] + normhalf) / norma[ee];
              ierr = (lc_error[ee][j] + normhalf) / norma[ee];
                
              sprintf(dummy, "%3d %2d", ival, ierr);
              for (i=0; i<6; i++) surface[iy][ix+i] = dummy[i];

           }
           printf("\n");
           fprintf(out, "\n");
           for (i=49; i>=0; i--) {
              surface[i][127] = 0;
              printf("%s\n", surface[i]);
              fprintf(out, "%s\n", surface[i]);
           }
           printf("\n");
           fprintf(out, "\n");
        }
        
}




