 /*
Routine to read the lc-out files generated by fits2lc_r
Summarizes the data for further analysis.
Output to "sweethome/$argv[2]/lc_out.gnu"
*/

#include<stdio.h>
#include<math.h>
#include<stdlib.h>
#include<string.h>

#define firstevent 32000.0
#define detdim 65536
#define srcnum 20
#define DATA_POINTS 25000 

/*#include<dos.h>*/
/* list of input files */

/* ***************************************************************************** */

main(argc,argv)
int argc ;
char *argv[] ;
{

	FILE *in1, *in2, *in3, *in0;
	FILE *out ;

	char iiname[100], iname[100], oname[100], dummy[1024], sweethome[200], finame[100];
        char surface[50][150];
          
        int i, j, k, orbit[10], pid[10][200], pidv[10][200], spix[10][4][200], bpix[10][4][200], jemx;
        int cmp_full[10][4][200], lc_raw[10][4][200], lc_backgr[10][4][200], ee, jmax[10][4]; 
        int collision, ival, ierr, ix, iy, normj[10][4], N_set, N, jm;
        int nx, ny, M00, orbit_M00, global_M00, M00_3, orbit_M00_3, global_M00_3; 
        int M00_4, orbit_M00_4, global_M00_4, M00_5, orbit_M00_5, global_M00_5;
        
        float lc_time[10][200], T_elapse[10][200], lc_livetime[10][200], norm_vals[10][4][200];
        float lc_error[10][4][200], dimmy1, dimmy2, dimmy3, normhalf, rate, SN, fval, ferr;
        float neighbor_s[10][4][200], expfact[10][4][200], dimmyf, lc_rate[10][4][200], ratemax[4];
        float lc_ratex1[10][4][200], lc_ratex2[10][4][200], lc_ratex3[10][4][200], lc_ratex4[10][4][200];
        float lc_difmax[10][4][200], lc_X[10][200], lc_Y[10][200], norma[10][4];
        float M0, M1, M2, orbit_M0, orbit_M1, orbit_M2, global_M0, global_M1, global_M2, wgt;
        float M0_3, M1_3, M2_3, orbit_M0_3, orbit_M1_3, orbit_M2_3, global_M0_3, global_M1_3, global_M2_3;
        float M0_4, M1_4, M2_4, orbit_M0_4, orbit_M1_4, orbit_M2_4, global_M0_4, global_M1_4, global_M2_4;
        float M0_5, M1_5, M2_5, orbit_M0_5, orbit_M1_5, orbit_M2_5, global_M0_5, global_M1_5, global_M2_5;
        float rx, ry, rrx, r;

        double mean, sigma;
        
        /* ********************************************* */
        
        sprintf(sweethome, "/home/nl/jemx/crab");
        ee = 0;
        for (i=0; i<10; i++) pid[i][199] = 999;
        
        if (argc > 2) jemx = atoi(argv[1]) ;           
        else {printf("jemx file_with_data_subdirectories\n"); return;}
        sprintf(finame, argv[2]);

        sprintf(dummy, "");
        sprintf(dummy, "lc_sigma_%1d.txt", jemx);
        strcpy(oname, dummy);
        printf("output_file: %s\n", dummy);

        out = fopen(oname, "wt");
        if (out == NULL) {
           printf("Could not open %s, exiting!\n", oname);
           return;
        }

        in0 = fopen(finame, "rt");
        if (in0 == NULL) {
           printf("Could not open %s, exiting!\n", finame);
           return;
        }
        
        N = 0;
        orbit_M0 = orbit_M1 = orbit_M2 = global_M0 = global_M1 = global_M2 = 0.0;
        orbit_M0_3 = orbit_M1_3 = orbit_M2_3 = global_M0_3 = global_M1_3 = global_M2_3 = 0.0;
        orbit_M0_4 = orbit_M1_4 = orbit_M2_4 = global_M0_4 = global_M1_4 = global_M2_4 = 0.0;
        orbit_M0_5 = orbit_M1_5 = orbit_M2_5 = global_M0_5 = global_M1_5 = global_M2_5 = 0.0;
        M00 = orbit_M00 = global_M00 = 0;
        M00_3 = orbit_M00_3 = global_M00_3 = 0;
        M00_4 = orbit_M00_4 = global_M00_4 = 0;
        M00_5 = orbit_M00_5 = global_M00_5 = 0;
        
next:   fgets(iiname, 100, in0);
   	if (feof(in0)) goto end0;
        i = strlen(iiname);
        iiname[i-1] = 0;
        
        for (ee=0; ee<4; ee++) {
           sprintf(dummy, "");
           sprintf(dummy, "%s/lc_out_%1d.txt", iiname, ee);
           strcpy(iname, dummy);
/*           printf("input_file: %s\n", dummy);
*/        
           in1 = fopen(iname, "rt");
           if (in1 == NULL) {
              printf("Could not open %s, exiting!\n", iname);
              return;
           }
/*           printf(" orb  pid    T_stamp  T_elaps livetime  spix   raw   bpix  backg  norm_v  rate1  ");
           printf(" error   difmax  X     Y \n");
*/
        
           fgets(dummy, 140, in1);
        
           for (j=0; j<200; j++) {

              fgets(dummy, 140, in1);
              if (feof(in1)) goto end1;
              jm = j;
               /* read summary ascii file */
            
              sscanf(dummy, "%d %d %f %f %f %d %d %d %d %f %f %f %f %f %f %f %f %f %f", 
                 &orbit[N], &pid[N][j], &lc_time[N][j], &T_elapse[N][j], &lc_livetime[N][j], 
                 &spix[N][ee][j], &lc_raw[N][ee][j], &bpix[N][ee][j], &lc_backgr[N][ee][j], 
                 &norm_vals[N][ee][j], &lc_rate[N][ee][j], &lc_error[N][ee][j],
                 &dimmy1, &dimmy2, &dimmy3, &dimmyf, 
                 &lc_difmax[N][ee][j], &lc_X[N][j], &lc_Y[N][j]);
                 
              if ((norma[N][ee] == 0) && (pid[N][j] > 5) && 
                       (abs(lc_X[N][j] - 129.0) < 3.0) && (abs(lc_Y[N][j] - 130.0) < 3.0)) {
                 norma[N][ee] = lc_rate[N][ee][j] / 100.0;
                 normj[N][ee] = j;
              }
              if ((orbit[N] == 102) && (jemx == 1)) {
                 norma[N][0] = 0.35;
                 norma[N][1] = 0.68;
                 norma[N][2] = 0.36;
                 norma[N][3] = 0.21;
                 normj[N][ee] = 199;
              }
           }
end1:	   fclose(in1);
   	   
           printf("JEM-X%1d E%1d Orbit: %3d, pids: %3d to %3d. Crab rates, ", 
              jemx, ee, orbit[N], pid[N][0], pid[N][jm-1]);
           printf("Norm. rate: %6.2f, at pid: %3d\n", norma[N][ee]*100.0, pid[N][normj[N][ee]]);

           M00 = 0;
           M0 = M1 = M2 = 0.0;
           for (j=0; j<jm; j++) {

              fval = lc_rate[N][ee][j] / norma[N][ee];
              ferr = lc_error[N][ee][j] / norma[N][ee];              
              wgt = 1.0 / (ferr * ferr);
              
              M00++;
              M0 += wgt;
              M1 += fval * wgt;
              M2 += fval * fval * wgt;
           }
           
           if (M0 > 0.0) {
              mean = M1 / M0;
              norma[N][ee] *= mean / 100.0;
           }
           
           M00 = M00_3 = M00_4 = M00_5 = 0;
           M0 = M1 = M2 = 0.0;
           M0_3 = M1_3 = M2_3 = 0.0;
           M0_4 = M1_4 = M2_4 = 0.0;
           M0_5 = M1_5 = M2_5 = 0.0;
           
           for (j=0; j<jm; j++) {

              fval = lc_rate[N][ee][j] / norma[N][ee];
              ferr = lc_error[N][ee][j] / norma[N][ee];              
              wgt = 1.0 / (ferr * ferr);
              
              M00++;
              M0 += wgt;
              M1 += fval * wgt;
              M2 += fval * fval * wgt;

              r = sqrt((double)((lc_X[N][j]-129.0) * (lc_X[N][j]-129.0) + (lc_Y[N][j]-131.0) * (lc_Y[N][j]-131.0)));
              if (r < 60.0) {
                 M00_3++;
                 M0_3 += wgt;
                 M1_3 += fval * wgt;
                 M2_3 += fval * fval * wgt;
              }
              if (r < 80.0) {
                 M00_4++;
                 M0_4 += wgt;
                 M1_4 += fval * wgt;
                 M2_4 += fval * fval * wgt;
              }
              if (r < 100.0) {
                 M00_5++;
                 M0_5 += wgt;
                 M1_5 += fval * wgt;
                 M2_5 += fval * fval * wgt;
              }
           }
           
           if (M0 > 0.0) {
              mean = M1 / M0;
              sigma = sqrt((double)(M2 / M0) - mean * mean);
           } else mean = sigma = 0.0;
           
           orbit_M00 += M00;
           orbit_M0 += M0;
           orbit_M1 += M1;
           orbit_M2 += M2;

           orbit_M00_3 += M00_3;
           orbit_M0_3 += M0_3;
           orbit_M1_3 += M1_3;
           orbit_M2_3 += M2_3;

           orbit_M00_4 += M00_4;
           orbit_M0_4 += M0_4;
           orbit_M1_4 += M1_4;
           orbit_M2_4 += M2_4;

           orbit_M00_5 += M00_5;
           orbit_M0_5 += M0_5;
           orbit_M1_5 += M1_5;
           orbit_M2_5 += M2_5;
           
           printf("%3d contributions. Weighted mean rate: %8.2lf, sigma: %6.2lf\n\n", M00, mean, sigma);
              
/*
              if ((abs(lc_X[N][j] - 129.0) < 3.0) && (abs(lc_Y[N][j] - 130.0) < 3.0)) {
              
           for (i=0; i<50; i++) for (j=0; j<150; j++) surface[i][j] = ' ';
           for (j=0; j<jm; j++) {
              ix = (lc_X[N][j] - 30.0) * 12.0 / 20.0;
              iy = (lc_Y[N][j] - 40.0) * 5.0 / 20.0;

              fval = lc_rate[N][ee][j] / norma[N][ee];
              ferr = lc_error[N][ee][j] / norma[N][ee];
              
              ival = fval + 0.5;
              ierr = ferr + 0.5;
                
              collision = 0;
              for (i=ix-1; i<ix+8; i++) if (surface[iy][i] != ' ') collision = 1;
              if (collision == 1) iy--;
              collision = 0;
              for (i=ix-1; i<ix+8; i++) if (surface[iy][i] != ' ') collision = 1;
              if (collision == 1) iy--;

              sprintf(dummy, "%3d %2d", ival, ierr);
              for (i=0; i<6; i++) surface[iy][ix+i] = dummy[i];
           }

           printf("\n");
           fprintf(out, "\n");
           for (i=49; i>=0; i--) {
              surface[i][127] = 0;
              printf("%s\n", surface[i]);
              fprintf(out, "%s\n", surface[i]);
           }
           printf("\n");
           fprintf(out, "\n");
*/
           jmax[N][ee] = jm;
        }

        global_M00 += orbit_M00;
        global_M00_3 += orbit_M00_3;
        global_M00_4 += orbit_M00_4;
        global_M00_5 += orbit_M00_5;
        global_M0 += orbit_M0;
        global_M1 += orbit_M1;
        global_M2 += orbit_M2;
        global_M0_3 += orbit_M0_3;
        global_M1_3 += orbit_M1_3;
        global_M2_3 += orbit_M2_3;
        global_M0_4 += orbit_M0_4;
        global_M1_4 += orbit_M1_4;
        global_M2_4 += orbit_M2_4;
        global_M0_5 += orbit_M0_5;
        global_M1_5 += orbit_M1_5;
        global_M2_5 += orbit_M2_5;
        
        if (orbit_M0 > 0.0) {
           mean = orbit_M1 / orbit_M0;
           sigma = sqrt((double)(orbit_M2 / orbit_M0) - mean * mean);
        } else mean = sigma = 0.0;
           
        printf("Orbital average over %3d contributions.      Weighted mean rate: %8.2lf, sigma: %6.2lf\n\n", 
            orbit_M00, mean, sigma);
         
        orbit_M00 = 0;
        orbit_M0 = orbit_M1 = orbit_M2 = 0.0;
        
        if (orbit_M0_5 > 0.0) {
           mean = orbit_M1_5 / orbit_M0_5;
           sigma = sqrt((double)(orbit_M2_5 / orbit_M0_5) - mean * mean);
        } else mean = sigma = 0.0;
           
        printf("Orbital average over %3d < 5 deg contributions.  Weighted mean rate: %8.2lf, sigma: %6.2lf\n\n", 
            orbit_M00_5, mean, sigma);
         
        orbit_M00_5 = 0;
        orbit_M0_5 = orbit_M1_5 = orbit_M2_5 = 0.0;
        
        if (orbit_M0_4 > 0.0) {
           mean = orbit_M1_4 / orbit_M0_4;
           sigma = sqrt((double)(orbit_M2_4 / orbit_M0_4) - mean * mean);
        } else mean = sigma = 0.0;
           
        printf("Orbital average over %3d < 4 deg contributions.  Weighted mean rate: %8.2lf, sigma: %6.2lf\n\n", 
            orbit_M00_4, mean, sigma);
         
        orbit_M00_4 = 0;
        orbit_M0_4 = orbit_M1_4 = orbit_M2_4 = 0.0;
        
        if (orbit_M0_3 > 0.0) {
           mean = orbit_M1_3 / orbit_M0_3;
           sigma = sqrt((double)(orbit_M2_3 / orbit_M0_3) - mean * mean);
        } else mean = sigma = 0.0;
           
        printf("Orbital average over %3d < 3 deg. contributions.  Weighted mean rate: %8.2lf, sigma: %6.2lf\n\n", 
            orbit_M00_3, mean, sigma);
         
        orbit_M00_3 = 0;
        orbit_M0_3 = orbit_M1_3 = orbit_M2_3 = 0.0;
        
        N++;
        goto next;
        
end0:
        if (global_M0 > 0.0) {
           mean = global_M1 / global_M0;
           sigma = sqrt((double)(global_M2 / global_M0) - mean * mean);
        } else mean = sigma = 0.0;
           
        printf("Global average over %4d contributions.      Weighted mean rate: %8.2lf, sigma: %6.2lf\n", 
           global_M00, mean, sigma);
         
        if (global_M0_5 > 0.0) {
           mean = global_M1_5 / global_M0_5;
           sigma = sqrt((double)(global_M2_5 / global_M0_5) - mean * mean);
        } else mean = sigma = 0.0;
           
        printf("Global average over %4d < 5 deg. contributions.  Weighted mean rate: %8.2lf, sigma: %6.2lf\n", 
           global_M00_5, mean, sigma);
         
        if (global_M0_4 > 0.0) {
           mean = global_M1_4 / global_M0_4;
           sigma = sqrt((double)(global_M2_4 / global_M0_4) - mean * mean);
        } else mean = sigma = 0.0;
           
        printf("Global average over %4d < 4 deg. contributions.  Weighted mean rate: %8.2lf, sigma: %6.2lf\n", 
           global_M00_4, mean, sigma);
         
        if (global_M0_3 > 0.0) {
           mean = global_M1_3 / global_M0_3;
           sigma = sqrt((double)(global_M2_3 / global_M0_3) - mean * mean);
        } else mean = sigma = 0.0;
           
        printf("Global average over %4d < 3 deg. contributions.  Weighted mean rate: %8.2lf, sigma: %6.2lf\n", 
           global_M00_3, mean, sigma);
         
	
}




