 /*
Routine to read the lc-out files generated by fits2lc_r
Summarizes the data for further analysis.
Output to "sweethome/$argv[2]/lc_out.gnu"
*/

#include<stdio.h>
#include<math.h>
#include<stdlib.h>
#include<string.h>

#define firstevent 32000.0
#define detdim 65536
#define srcnum 20
#define DATA_POINTS 25000 

/*#include<dos.h>*/
/* list of input files */

/* ***************************************************************************** */

main(argc,argv)
int argc ;
char *argv[] ;
{

	FILE *in1, *in2, *in3, *in0;
	FILE *out ;

	char iiname[100], iname[100], oname[100], dummy[1024], sweethome[200], finame[100];
        char surface[50][150];
          
        int i, j, k, orbit[10], pid[10][200], pidv[10][200], spix[10][4][200], bpix[10][4][200], jemx;
        int cmp_full[10][4][200], lc_raw[10][4][200], lc_backgr[10][4][200], ee, jmax[10][4]; 
        int collision, ival, ierr, ix, iy, normj[10][4], N_set, N, jm;
        int nx, ny, M00, orbit_M00, global_M00, M00_3, orbit_M00_3, global_M00_3; 
        int M00_4, orbit_M00_4, global_M00_4, M00_5, orbit_M00_5, global_M00_5;
        
        float lc_time[10][200], T_elapse[10][200], lc_livetime[10][200], norm_vals[10][4][200];
        float lc_error[10][4][200], dimmy1, dimmy2, dimmy3, normhalf, rate, SN, fval, ferr;
        float neighbor_s[10][4][200], expfact[10][4][200], dimmyf, lc_rate[10][4][200], ratemax[4];
        float lc_ratex1[10][4][200], lc_ratex2[10][4][200], lc_ratex3[10][4][200], lc_ratex4[10][4][200];
        float lc_difmax[10][4][200], lc_X[10][200], lc_Y[10][200], norma[10][4];
        float M0, M1, M2, orbit_M0, orbit_M1, orbit_M2, global_M0, global_M1, global_M2, wgt;
        float M0_3, M1_3, M2_3, orbit_M0_3, orbit_M1_3, orbit_M2_3, global_M0_3, global_M1_3, global_M2_3;
        float M0_4, M1_4, M2_4, orbit_M0_4, orbit_M1_4, orbit_M2_4, global_M0_4, global_M1_4, global_M2_4;
        float M0_5, M1_5, M2_5, orbit_M0_5, orbit_M1_5, orbit_M2_5, global_M0_5, global_M1_5, global_M2_5;
        float rx, ry, rrx, r;

        double mean, sigma, offX, offY, offax, signal, err;
        
        /* ********************************************* */
        
        sprintf(sweethome, "/home/nl/jemx/crab");
        ee = 0;
        for (i=0; i<10; i++) pid[i][199] = 999;
        
        if (argc > 2) jemx = atoi(argv[1]) ;           
        else {printf("jemx file_with_data_subdirectories\n"); return;}
        sprintf(finame, argv[2]);

        in0 = fopen(finame, "rt");
        if (in0 == NULL) {
           printf("Could not open %s, exiting!\n", finame);
           return;
        }
        
        N = 0;
        orbit_M0 = orbit_M1 = orbit_M2 = global_M0 = global_M1 = global_M2 = 0.0;
        orbit_M0_3 = orbit_M1_3 = orbit_M2_3 = global_M0_3 = global_M1_3 = global_M2_3 = 0.0;
        orbit_M0_4 = orbit_M1_4 = orbit_M2_4 = global_M0_4 = global_M1_4 = global_M2_4 = 0.0;
        orbit_M0_5 = orbit_M1_5 = orbit_M2_5 = global_M0_5 = global_M1_5 = global_M2_5 = 0.0;
        M00 = orbit_M00 = global_M00 = 0;
        M00_3 = orbit_M00_3 = global_M00_3 = 0;
        M00_4 = orbit_M00_4 = global_M00_4 = 0;
        M00_5 = orbit_M00_5 = global_M00_5 = 0;
        
      	sprintf(dummy, "");
        sprintf(dummy, "sl_plot_%1d.gnu", jemx);
        strcpy(oname, dummy);
        printf("output_file: %s\n", dummy);

        out = fopen(oname, "wt");
        if (out == NULL) {
           printf("Could not open %s, exiting!\n", oname);
           return;
        }

next:   fgets(iiname, 100, in0);
   	if (feof(in0)) goto end0;
        i = strlen(iiname);
        iiname[i-1] = 0;
        
        N_set = N+1;

        for (ee=0; ee<4; ee++) {
           sprintf(dummy, "");
           sprintf(dummy, "%s/lc_out_%1d.txt", iiname, ee);
           strcpy(iname, dummy);
/*           printf("input_file: %s\n", dummy);
*/        
           in1 = fopen(iname, "rt");
           if (in1 == NULL) {
              printf("Could not open %s, exiting!\n", iname);
              return;
           }
/*           printf(" orb  pid    T_stamp  T_elaps livetime  spix   raw   bpix  backg  norm_v  rate1  ");
           printf(" error   difmax  X     Y \n");
*/
        
           fgets(dummy, 140, in1);
        
           for (j=0; j<200; j++) {

              jm = j;
              fgets(dummy, 140, in1);
              if (feof(in1)) goto end1;
               /* read summary ascii file */
            
              sscanf(dummy, "%d %d %f %f %f %d %d %d %d %f %f %f %f %f %f %f %f %f %f", 
                 &orbit[N], &pid[N][j], &lc_time[N][j], &T_elapse[N][j], &lc_livetime[N][j], 
                 &spix[N][ee][j], &lc_raw[N][ee][j], &bpix[N][ee][j], &lc_backgr[N][ee][j], 
                 &norm_vals[N][ee][j], &lc_rate[N][ee][j], &lc_error[N][ee][j],
                 &dimmy1, &dimmy2, &dimmy3, &dimmyf, 
                 &lc_difmax[N][ee][j], &lc_X[N][j], &lc_Y[N][j]);
                 
              if ((norma[N][ee] == 0) && (pid[N][j] > 5) && 
                       (abs(lc_X[N][j] - 129.0) < 3.0) && (abs(lc_Y[N][j] - 130.0) < 3.0)) {
                 norma[N][ee] = lc_rate[N][ee][j] / 100.0;
                 normj[N][ee] = j;
              }
              if ((orbit[N] == 102) && (jemx == 1)) {
                 norma[N][0] = 0.35;
                 norma[N][1] = 0.68;
                 norma[N][2] = 0.36;
                 norma[N][3] = 0.21;
                 normj[N][ee] = 199;
              }
           }
end1:	   jmax[N][0] = jm;
   	   fclose(in1);
   	}
        N++;
        goto next;
end0:   fclose(in0);
        fprintf(out, "%6.2lf  %8.4lf  %8.4lf\n", 0.0, 0.0, 0.0);
   	for (N=0; N<N_set; N++) {
           for (j=0; j<jmax[N][0]; j++) {
              offX = lc_X[N][j] - 129.0;
              offY = lc_Y[N][j] - 130.0;
              offax = sqrt(offX*offX + offY*offY) * 6.6 / 127.0;
              signal = err = 0.0;
              for (ee=0; ee<4; ee++) {
                 signal += lc_rate[N][ee][j];
                 err += lc_error[N][ee][j] * lc_error[N][ee][j];
              }
              err = sqrt(err);
              fprintf(out, "%6.2lf  %8.4lf  %8.4lf\n", offax, signal, err);
           }
           fprintf(out,"\n\n");
        }
        fclose(out);
        return;
}




